//This file implements the List class

//Suggested Further Exercises: 

//1. Add a tail member to the private
//data members of the List class
//If you do this what List method becomes trivial
//to implement ?

//2. Implement a List method Reverse
//that reverses a list (header given in List.h)


#include <iostream>
#include "List.h"

using namespace std;

//List Constructor
//Initializes the head of the list

List :: List() {
  head = NULL;
}

//List Copy constructor
//This concept will be covered in class soon
//if it has not been covered already.
//Performs a "deep" copy of the List l given
//as argument:
//For each node crt in the l list creates a new node tmp and copies 
//the value from node crt into tmp

List :: List (const List& l){
 
  if(!l.head) {
    head = NULL;
  }
  else
    {
      head = new ListNode (l.head->GetVal(), NULL);
      if (head == NULL) exit (0);

      ListNode *last = head;
      for (ListNode *crt = l.head->GetNext(); crt != NULL; crt = crt->GetNext()){
		ListNode *tmp;
		tmp = new ListNode(crt->GetVal(), NULL);
		last->SetNext(tmp);
		last = tmp;
      }
    } 
}

//List Destructor:
//Deallocates space that was allocated to each node
//in the current list

List::~List() {
  ListNode *tmp;
  for (ListNode *crt = head; crt != NULL; crt = tmp){
    tmp = crt->GetNext();
    delete crt;
  }
}

//List Public Method Tail
//Returns a pointer to the list's last node
//or NULL if the list is empty

ListNode * List :: Tail() {

  if (head == NULL)
	return NULL;

  ListNode *prev, *crt;
  for (prev = NULL, crt = head; crt != NULL; crt = crt->GetNext()){
    prev = crt;
  }
  return prev;
}



//List Public Method AddNode
//Adds a node to the current List at the beginning
//Creates a new List node 
//Note that the ListNode constructor is invoked.
//Updates head to point to the newly created node
   
void List :: AddNode (Type val){
      ListNode *tmp = new ListNode(val, head);
      if (tmp == NULL) exit (0);
      head = tmp;
}


//List Public Method AppendNode
//Adds a node to the current List at the end
//Needs to get to the end of the list first
//creates a new node and updates the last
//node in the list to point to the newly created node.

   
void List :: AppendNode (Type val){
      ListNode *tmp = new ListNode(val, NULL);
      if (tmp == NULL) exit (0);
	  ListNode *last = Tail();
	  last->SetNext(tmp);
}


//List Public Method Display
//Displays the current List

void List :: Display () {
  cout << "List content:";
  for (ListNode *crt= head; crt != NULL; crt = crt->GetNext())
    cout << " " << crt->GetVal();
  cout << endl;
}
      







